#include <math.h> 

static double a[101];

static double gammln(float xx) {
/*** Return ln[Gamma(xx)], xx > 0		
****Internal arithmetic will be done in double precision, */	

	static double cof[6] = {76.18009172947146,-86.50532032941677,
													24.01409824083091,-1.231739572450155,
													0.1208650973866179e-2,-0.5395239384953e-5};

	double x=xx;
	double y=xx;
	double tmp=x+5.5;
	tmp -= (x+0.5)*log(tmp);
	double ser = 1.000000000190015;
	for (int j=0;j<=5;j++) ser += cof[j]/++y; 
	return (-tmp+log(2.5066282746310005*ser/x));
}

static double factln(int n) {

	if ( n <= 1 )
		return 0.0;
	else
		return gammln(float(n) + 1.0);
}

double bicoeff(int n,int k) {
	return floor(0.5 + exp(factln(n) - factln(k) - factln(n-k)));
}
