#ifndef GRAPH_H
#define GRAPH_H

#include <stdio.h>
#include <stdlib.h>
#include <map>

#include "InputSet.h"

struct Neighbor {
  int v;
  int t;
  int s;
  double prob;

  Neighbor(int V,int T,int S) {
    v = V;
    t = T;
    s = S;
  }

  Neighbor(int V,double p) {
    v = V;
    prob = p;
  }

};

struct Node {
  int v;
  int frequency;
  vector<Neighbor> mAdjacency;

  Node() {}

  Node(int i, int freq) {
    v = i;
    frequency = freq;
  }
};


class CGraph {
 public:  
  CGraph() {}
  CGraph(int nV);
  CGraph(InputPurifications &instance);

  ~CGraph();

  int mNVertices;
  
  vector<string> mLabels;

  vector<Node> mNodes;  
};

class CSpokeGraph : public CGraph {

 public:
  
  CSpokeGraph(InputPurifications &instance, double tau);
};

class CRandomObs : public CGraph {

 public:
  
  CRandomObs(InputPurifications &instance, char *clusterfile);

  map<string, int, less<string> > name2cluster;

  vector<int> mClasses;
};

class CRandomCluster : public CGraph {

 public:
  CRandomCluster(int nV, int nK);

  vector<int> mClasses;
};

class CFixSizes : public CGraph {

 public:
  CFixSizes(char *sizefile);
  
  vector<int> mClasses;
};

#endif
