#include <stdio.h>
#include <stdlib.h>

const double EPSILON = 10e-5;

class CRandomField {

 public:

  CRandomField(int nV, int K);  
  ~CRandomField();

  void initialize();
  double reestimate(CGraph &G);
  double assignment(CGraph &G, int maxIteration);

  vector<int> mGroups;
  double mLambda;

  int mNumVars;
  int mNumClusters;

  double **mQ;

  double coOccurrence(CGraph &G);
};

class CAnnealing {

 public:
 
  CAnnealing(int nV, int K, double psi);
  ~CAnnealing();

  void initialize();
  double reestimate(CGraph &G, double gamma);
  double assignment(CGraph &G, int maxIteration);
  double coOccurrence(CGraph &G);
  double Likelihood(CGraph &G);

  vector<int> mGroups;
  double mLambda;
  double mFalseNegative;
  double mFalsePositive;
  double mPsi;

 private:

  int mNumVars;
  int mNumClusters;

  double **mQ;

  double RateEstimation(CGraph &G);
  double UpdatePsi();
};
